/*

  This file is part of EASYMOVE.DLL source code, see MAIN.C for
  detailed information.

  Copyright (C) 2000-2001 Pavel Vitis
  pavel.vitis@seznam.cz
  http://lsg.come.to/


  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

/****************************************************************************
****************************************************************************/

#include <windows.h>
#include <mmsystem.h>
#include "main.h"
#include "hookdll.h"
#include "lsapi.h"
#include <shellapi.h>
#include "../kmhook/hookdll.h"

// Actual shift keys state. Used when keyboard-hook is set
UINT shift_keys = 0;

// Has hotkey been pressed?
BOOL hotkey_pressed = FALSE;
BOOL easy_moved = FALSE;

HWND ToolWindow;

ATOM LWinKey;
ATOM RWinKey;

// active_win = window in foreground, mouse_win = window under mouse cursor
// at the time of stroke start
//static HWND active_win = NULL;
//static HWND mouse_win = NULL;

#define SK_KEYDOWN  0x8000
#define SK_SYSKEY   0x4000

UINT nMessages[] = {
	LM_GETREVID,
	LM_REFRESH,
	0
};


// Try to get main window
HWND GetMainWindow( HWND wnd )
{
	if (isAppWindow(wnd))
		return wnd;

	while ( ( GetParent(wnd) != NULL ) && !isAppWindow(wnd) )
	{
		LOGF("non-parent: %X", wnd);
		wnd = GetParent(wnd);
	}
	LOGF("parent: %X", wnd);

	return wnd;
}

// Play sound
void sound( LPCTSTR snd, LPCTSTR def )
{
	if ( snd )
		sndPlaySound( snd, SND_ASYNC | SND_NOSTOP );
	else
	if ( def )
		sndPlaySound( def, SND_ASYNC | SND_NOSTOP );
}

/*
#define TMOUT 100
// Try to cancel special cursor modes (dragging, selecting, context-menu open, etc.)
// after stroke start.
// This is very slicky and dirty, though sometimes not successful
BOOL CALLBACK cancelModeProc(HWND hwnd,	LPARAM lParam)
{
//	char classbuf[256];

//	GetClassName(hwnd, classbuf, sizeof(classbuf));
//	LOGF("Enumwnd: %s", classbuf);
	BOOL smres;
	DWORD result = 0;

	smres = SendMessageTimeout(hwnd, WM_CANCELMODE, 0, 0, SMTO_NORMAL | SMTO_ABORTIFHUNG, TMOUT, &result);
	smres = SendMessageTimeout(hwnd, WM_EXITSIZEMOVE, 0, 0, SMTO_NORMAL | SMTO_ABORTIFHUNG, TMOUT, &result);
	smres = SendMessageTimeout(hwnd, EM_SETSEL, -1, 0, SMTO_NORMAL | SMTO_ABORTIFHUNG, TMOUT, &result);
//	smres = SendMessageTimeout(hwnd, WM_CAPTURECHANGED, 0, 0, SMTO_NORMAL | SMTO_ABORTIFHUNG, TMOUT, &result);
	return TRUE;
}

void cancelModes( HWND wnd )
{
//	char classbuf[256];
	HWND twnd, twnd1;
	DWORD thid;
	BOOL smres;
	DWORD result = 0;

	twnd = wnd;
	do {
		SendMessageTimeout(twnd, WM_CANCELMODE, 0, 0, SMTO_NORMAL | SMTO_ABORTIFHUNG, TMOUT, &result);
		SendMessageTimeout(twnd, WM_CAPTURECHANGED, 0, 0, SMTO_NORMAL | SMTO_ABORTIFHUNG, TMOUT, &result);
		twnd = GetWindow(twnd, GW_HWNDPREV);
	} while ( twnd && (twnd != wnd) );

	EnumChildWindows(wnd, cancelModeProc, 0);

	if ( GetWindowThreadProcessId(wnd, &thid) != 0 )
		EnumThreadWindows(thid, cancelModeProc, 0);

	twnd = GetWindow(wnd, GW_CHILD);
	twnd1 = twnd;
	do {
		SendMessageTimeout(twnd, WM_CANCELMODE, 0, 0, SMTO_NORMAL | SMTO_ABORTIFHUNG, TMOUT, &result);
		SendMessageTimeout(twnd, WM_CAPTURECHANGED, 0, 0, SMTO_NORMAL | SMTO_ABORTIFHUNG, TMOUT, &result);
		twnd = GetWindow(twnd, GW_HWNDNEXT);
	} while ( twnd && (twnd != twnd1) );

	twnd = GetWindow(wnd, GW_HWNDFIRST);
	PostMessage(GetWindow(twnd, GW_OWNER), WM_CANCELMODE, 0, 0);
	PostMessage(GetWindow(twnd, GW_OWNER), WM_CAPTURECHANGED, 0, 0);

	PostMessage(GetWindow(wnd, GW_OWNER), WM_CANCELMODE, 0, 0);
	PostMessage(GetWindow(wnd, GW_OWNER), WM_CAPTURECHANGED, 0, 0);

	if ( twnd = GetParent(wnd) )
	{
		SendMessageTimeout(twnd, WM_CANCELMODE, 0, 0, SMTO_NORMAL | SMTO_ABORTIFHUNG, TMOUT, &result);
		SendMessageTimeout(twnd, WM_CAPTURECHANGED, 0, 0, SMTO_NORMAL | SMTO_ABORTIFHUNG, TMOUT, &result);
	}

	if ( twnd = GetCapture() )
	{
		SendMessageTimeout(twnd, WM_CANCELMODE, 0, 0, SMTO_NORMAL | SMTO_ABORTIFHUNG, TMOUT, &result);
		SendMessageTimeout(twnd, WM_CAPTURECHANGED, 0, 0, SMTO_NORMAL | SMTO_ABORTIFHUNG, TMOUT, &result);
	}

}

BOOL improperWindow(HWND wnd, char *class, int action)
{
	if (wnd == hDesktop)
		return TRUE;

	if (match("*twharf*", class) )
		return TRUE;

	if (match("*popupmenu*", class))
		return TRUE;

	if (match("*shortcutclass*", class))
		return TRUE;

	return FALSE;
}
*/

#define TIME_TO_WAIT 500
static DWORD waitCounterStart = 0;

void startWaiting()
{
	waitCounterStart = GetTickCount();
}

BOOL shouldWait()
{
	if (waitCounterStart == 0)
		return FALSE;

	int currentTicks = GetTickCount();
	if (currentTicks >= waitCounterStart && currentTicks <= waitCounterStart + TIME_TO_WAIT)
		return TRUE;

	waitCounterStart = 0;

	return FALSE;
}


BOOL isHotkey(int keys)
{
	if (hotkey_pressed)
		return TRUE;

	if ((keys & HK_SHIFT) == 0 && (keys & HK_ALT) == 0 && (keys & HK_CTRL) == 0)
		return FALSE;

	if ((keys & HK_SHIFT) != 0 && !SHIFTKEY)
		return FALSE;
	if ((keys & HK_ALT) != 0 && !ALTKEY)
		return FALSE;
	if ((keys & HK_CTRL) != 0 && !CTRLKEY)
		return FALSE;

	return TRUE;
}

void startDragging()
{
	POINT pt;
	POINTS pts;

	LOG("DRAGGING!!!");
	ReleaseCapture(); // This is not compulsory
	GetCursorPos(&pt);
  	pts.x = pt.x;
   	pts.y = pt.y;
	hotkey_pressed = FALSE;
	easy_moved = TRUE;
	PostMessage(GetMainWindow(WindowFromPoint(pt)), WM_NCLBUTTONDOWN, HTCAPTION, (LPARAM)&pts);
}

static MOUSEHOOKSTRUCT mhs;

//static UINT ignore_key = 0;

LRESULT WINAPI WndProc( HWND hWnd, UINT nMessage, WPARAM wParam, LPARAM lParam )
{
	char kblayout[KL_NAMELENGTH];
	LPTSTR pszBuf;

	// Only hotkey checking, no mouse button defined
	if ( nMessage == KeyboardMsg )
	{
		if (!config.enabled)
			return 0;
//		LOGF("KEY wParam: %08X", wParam);
//		LOGF("KEY lParam: %08X", lParam);

		// Is key-up?
		if (lParam & 0x80000000U)
		{
//			LOG("Key up");
			if ( wParam == VK_CAPITAL && config.hotkey == VK_CAPITAL)
			{
				if (shouldWait())
				{
					return 0;
				}
				else
				if (easy_moved)
				{
					easy_moved = FALSE;
					startWaiting();
					keybd_event(VK_CAPITAL, MapVirtualKey(VK_CAPITAL, 0), KEYEVENTF_EXTENDEDKEY, 0);
					keybd_event(VK_CAPITAL, MapVirtualKey(VK_CAPITAL, 0), KEYEVENTF_EXTENDEDKEY | KEYEVENTF_KEYUP, 0);
					return 0;
				}
			}
/*			else
			if ( wParam == VK_SHIFT )
			{
				shift_keys &= ~HK_SHIFT;
			}
			else
			if ( wParam == VK_MENU )
			{
				shift_keys &= ~HK_ALT;

//				LOG("ALT UP");
//				LOGF("easy_moved %d", easy_moved);
//				LOGF("hotkey_pressed %d", hotkey_pressed);
				if (easy_moved && hotkey_pressed && ((config.hotkey & HK_ALT) == HK_ALT))
				{
//					LOG("SWALLOW ALT");
					hotkey_pressed = FALSE;
					easy_moved = FALSE;
					return 1;
				}
			}
			else
			if ( wParam == VK_CONTROL )
			{
				shift_keys &= ~HK_CTRL;
			}

			// Hotkey has been released
			if ( config.hotkey != (shift_keys & config.hotkey) )
			{
				LOG("HOTKEY OFF!!!");
				hotkey_pressed = FALSE;
				easy_moved = FALSE;
			}
*/
		}
		else
		// Is key-down?
		// Ignore key-repeats (test for previous key state - must have been 'up').
		if ((lParam & 0x40000000U) == 0)
		{
//			LOG("Key down");
			if ( wParam == VK_CAPITAL && config.hotkey == VK_CAPITAL)
			{
//				LOG("CAPSLOCK Pressed");
				if (shouldWait())
				{
					return 0;
				}
				else
				{
					hotkey_pressed = TRUE;
				}
			}
/*			else
			{
				if ( wParam == VK_SHIFT )
				{
					shift_keys |= HK_SHIFT;
	//				LOG("SHIFT ON");
				}
				else
				if ( wParam == VK_MENU )
				{
					shift_keys |= HK_ALT;
	//				LOG("ALT ON");
				}
				else
				if ( wParam == VK_CONTROL )
				{
					shift_keys |= HK_CTRL;
	//				LOG("CTRL ON");
				}

				// Hotkey combination has been pressed
				if ( (shift_keys) == config.hotkey )
				{
					hotkey_pressed = TRUE;
					LOG("HOTKEY ON!!!");
				}
			}
*/
		}
		return 0;
	}

	if ( nMessage == MouseMsg )
	{
		if (!config.enabled)
			return 0;

		if ((PMOUSEHOOKSTRUCT) lParam != NULL)
			memcpy(&mhs, (PMOUSEHOOKSTRUCT) lParam, sizeof(MOUSEHOOKSTRUCT));

		switch (wParam)
		{
			case WM_MOUSEWHEEL:
				break;
			case WM_LBUTTONDOWN:
				if (config.mbutton == MK_LBUTTON && isHotkey(config.hotkey))
				{
					startDragging();
					return 1;
				}
				break;
			case WM_RBUTTONDOWN:
				if (config.mbutton == MK_RBUTTON && isHotkey(config.hotkey))
				{
					startDragging();
					return 1;
				}
				break;
			case WM_MBUTTONDOWN:
				if (config.mbutton == MK_MBUTTON && isHotkey(config.hotkey))
				{
					startDragging();
					return 1;
				}
				break;

			case WM_XBUTTONDOWN:
				if ((config.mbutton == MK_XBUTTON1 || config.mbutton == MK_XBUTTON2) && isHotkey(config.hotkey))
				{
					startDragging();
					return 1;
				}
				break;

			case WM_RBUTTONUP:
			case WM_NCRBUTTONUP:
				break;
			case WM_LBUTTONUP:
			case WM_NCLBUTTONUP:
				break;
			case WM_MBUTTONUP:
			case WM_NCMBUTTONUP:
				break;

			case WM_MOUSEMOVE:
			case WM_NCMOUSEMOVE:
				break;

		}
		return 0;
	}

	switch( nMessage )
	{
		case WM_HOTKEY:
/*
			if (isKeyInList((ATOM)wParam)){
				if (LWinKey)
					KillTimer(hMainWnd, 1);
				if (RWinKey)
					KillTimer(hMainWnd, 2);
				LSExecute(hMainWnd, jkeys[getKeyById((ATOM)wParam)].cmd, 0);
			}
			else if (LWinKey && (ATOM)wParam == LWinKey)
				SetTimer(hMainWnd, 1, jks.nLWinKeyTimeout, (TIMERPROC)NULL);
			else if (RWinKey && (ATOM)wParam == RWinKey)
				SetTimer(hMainWnd, 2, jks.nRWinKeyTimeout, (TIMERPROC)NULL);
*/
//			LOG("WinKey pressed!");
			break;

		case WM_TIMER:
			break;
		case WM_CREATE:     // window create ok
			return 0;
			break;
		case WM_ERASEBKGND: // don't erase background
			return 0;
			break;
		case WM_PAINT:
			return 0;
			break;
		case WM_KEYDOWN:    // forward keyboard messages to parent window
//			PostMessage(parent,msg,wParam,lParam);
//	result:=0;
			break;
		case WM_KEYUP:
//			PostMessage(parent,msg,wParam,lParam);
//	result:=0;
			break;
		case LM_GETREVID:
			pszBuf = (LPTSTR) lParam;
			if( wParam == 0 || wParam == 1 )
				strcpy( pszBuf, ST_REVID );
			else
				pszBuf[0] = 0;
			return strlen( pszBuf );
			break;
		case LM_REFRESH:
			LOG("LM_REFRESH received. Reloading config.");
			reloadConfig();
			break;
	}

	return DefWindowProc( hWnd, nMessage, wParam, lParam );
}

BOOL createToolWindow(void)
{
	WNDCLASS wc;

	// register main window class
	memset(&wc, '\0', sizeof(wc));
//	wc.cbSize = sizeof(WNDCLASSEX);
	wc.style = CS_DBLCLKS | CS_NOCLOSE;;
	wc.lpfnWndProc = (WNDPROC) WndProc;
//	wc.cbClsExtra = 0;
//	wc.cbWndExtra = 0;
	wc.hInstance = DLLInstance;
///	wc.hCursor = LoadCursor( NULL, IDC_ARROW );
///	wc.hIcon = NULL;
//	wc.hbrBackground = NULL;
//	wc.lpszMenuName = NULL;
	wc.lpszClassName = WC_MAIN;
//	wc.hIconSm = NULL;

	if (RegisterClass(&wc) == 0)
		return FALSE;

	// create main module window
	ToolWindow = CreateWindowEx(
		WS_EX_NOPARENTNOTIFY | WS_EX_TOOLWINDOW | WS_EX_TRANSPARENT,
		WC_MAIN,
		NULL,
		WS_POPUP,
		0,
		0,
		0,
		0,
		NULL,
		0,
		DLLInstance,
		NULL );

	if (ToolWindow == NULL)
	{
		UnregisterClass( WC_MAIN, DLLInstance );
		return FALSE;
	}

	// hide us from the VWM and set initial visibility state
	SetWindowLong( ToolWindow, GWL_USERDATA, magicDWord );
	SetParent( ToolWindow, hLitestep );

	// register for messages from the LS core
	SendMessage( hLitestep, LM_REGISTERMESSAGE, (WPARAM) ToolWindow, (LPARAM) nMessages );

	return TRUE;
}

void destroyToolWindow(void)
{
	SendMessage( hLitestep, LM_UNREGISTERMESSAGE, (WPARAM) ToolWindow, (LPARAM) nMessages );
	DestroyWindow( ToolWindow );
	UnregisterClass( WC_MAIN, DLLInstance );
}

